#!/bin/bash

gpu_list="${CUDA_VISIBLE_DEVICES:-0}"
IFS=',' read -ra GPULIST <<< "$gpu_list"

CHUNKS=${#GPULIST[@]}

CKPT="llava_15_7b_lora_instruct_60k_single_SVIT_clip_score_related_2P_0419_lora_merge"
SPLIT="llava_gqa_testdev_balanced"
GQADIR="/code/NIPS_2024/DATASET/VQA_Dataset/gqa"



# --model-path /code/NIPS_2024/Model/llava-v1.5-7b
# --model-path /code/NIPS_2024/Model/llava-v1.5-7b-lora_merge  \
# --model-path /code/NIPS_2024/Llava_Med/checkpoints/llava-v1.5-7b-lora_merge_demo  \
# --model-path  /code/NIPS_2024/Llava_Med/checkpoints/llava_15_7b_lora_instruct_10k_0321_lora_merge
# --model-path  /code/NIPS_2024/Llava_Med/checkpoints/llava_15_7b_lora_instruct_10k_related_0321_lora_merge
# --model-path  /code/NIPS_2024/Llava_Med/checkpoints/llava_15_7b_lora_instruct_10k_after_chat_single_ours_version_0322_lora_merge
# --model-path  /code/NIPS_2024/Llava_Med/checkpoints/llava_15_7b_lora_instruct_10k_after_chat_single_ours_version_related_0322_lora_merge




for IDX in $(seq 0 $((CHUNKS-1))); do
    CUDA_VISIBLE_DEVICES=${GPULIST[$IDX]} python -m llava.eval.model_vqa_loader \
        --model-path /code/NIPS_2024/LLaVA/checkpoints/llava_15_7b_lora_instruct_60k_single_SVIT_clip_score_related_2P_0419_lora_merge \
        --question-file /code/NIPS_2024/DATASET/VQA_Dataset/gqa/$SPLIT.jsonl \
        --image-folder /code/NIPS_2024/DATASET/VQA_Dataset/gqa/images \
        --answers-file /code/NIPS_2024/DATASET/VQA_Dataset/gqa/answers/$SPLIT/$CKPT/${CHUNKS}_${IDX}.jsonl \
        --num-chunks $CHUNKS \
        --chunk-idx $IDX \
        --temperature 0 \
        --conv-mode vicuna_v1 &
done

wait

output_file=/code/NIPS_2024/DATASET/VQA_Dataset/gqa/answers/$SPLIT/$CKPT/merge.jsonl

# Clear out the output file if it exists.
> "$output_file"

# Loop through the indices and concatenate each file.
for IDX in $(seq 0 $((CHUNKS-1))); do
    cat /code/NIPS_2024/DATASET/VQA_Dataset/gqa/answers/$SPLIT/$CKPT/${CHUNKS}_${IDX}.jsonl >> "$output_file"
done

python scripts/convert_gqa_for_eval.py --src $output_file --dst $GQADIR/testdev_balanced_predictions.json

cd $GQADIR
python eval/eval.py --tier testdev_balanced



# bash scripts/v1_5/eval/gqa.sh


############################  llava-v1.5-7b ############################
# Binary: 79.16%
# Open: 47.32%
# Accuracy: 61.93%
# Validity: 0.00%
# Plausibility: 0.00%
# Distribution: 1.64 (lower is better)

# Accuracy / structural type:
#   choose: 83.35% (1129 questions)
#   compare: 65.03% (589 questions)
#   logical: 75.93% (1803 questions)
#   query: 47.32% (6805 questions)
#   verify: 83.35% (2252 questions)

# Accuracy / semantic type:
#   attr: 68.22% (5186 questions)
#   cat: 53.26% (1149 questions)
#   global: 63.69% (157 questions)
#   obj: 87.66% (778 questions)
#   rel: 53.84% (5308 questions)



############################  llava_15_7b_lora_instruct_60k_single_SVIT_clip_score_related_2P_0419_lora_merge ############################
# Binary: 73.41%
# Open: 46.94%
# Accuracy: 59.09%
# Validity: 0.00%
# Plausibility: 0.00%
# Distribution: 1.52 (lower is better)

# Accuracy / structural type:
#   choose: 82.11% (1129 questions)
#   compare: 60.44% (589 questions)
#   logical: 71.55% (1803 questions)
#   query: 46.94% (6805 questions)
#   verify: 73.93% (2252 questions)

# Accuracy / semantic type:
#   attr: 64.29% (5186 questions)
#   cat: 51.44% (1149 questions)
#   global: 59.24% (157 questions)
#   obj: 85.60% (778 questions)
#   rel: 51.77% (5308 questions)

 